import java.util.ArrayList;

/**
 * Stellt die Verbindung zur "Datenbank" her
 * Die "Datenbank" sind hier nur beispieldaten.
 */
public class DBConnection {
    private ArrayList<TradingDeal> tradingDeals;
    private ArrayList<Package> packages;

    /**
     * Erstellt alle Beispieldaten und simuliert somit den
     * Verbindungsaufbau zu einer DB
     */
    public DBConnection(){
        Card c1 = new Card("Name", 10, ElementTyp.FIRE, CardType.MONSTER);
        Card c2 = new Card("Name1", 12, ElementTyp.FIRE, CardType.SPELL);
        Card c3 = new Card("Name2", 13, ElementTyp.WATER, CardType.MONSTER);
        Card c4 = new Card("Name3", 14, ElementTyp.WATER, CardType.SPELL);
        Card c5 = new Card("Name4", 15, ElementTyp.FIRE, CardType.MONSTER);
        Cards deck = new Cards();
        Cards stack = new Cards();
        deck.addCard(c1);
        deck.addCard(c2);
        stack.addCard(c3);
        stack.addCard(c4);
        stack.addCard(c5);
        User user = new User(new Credentials("username", "passwort"), "Name", "Nachname", "Email", new Stack(stack, deck), new Coins(1000));
        this.tradingDeals.add(new TradingDeal(user, c1, ElementTyp.FIRE, 10, CardType.SPELL));
        this.packages.add(new Package(stack, "Test Package", 100));
    }

    /**
     * Holt alle verfügbaren TradingDeals
     * @return Alle Trading Deals
     */
    public ArrayList<TradingDeal> getAllTradingDeals(){
        return this.tradingDeals;
    }

    /**
     * Holt alle verfügbaren Packages
     * @return Alle Packages
     */
    public ArrayList<Package> getAllPackages(){
        return this.packages;
    }

    /**
     * Fügt einen neuen Tradingdeal zum Store hinzu
     * @param tradingDeal Der neue Deal
     */
    public void addTradingDeal(TradingDeal tradingDeal){
        this.tradingDeals.add(tradingDeal);
    }

    /**
     * Fügt ein neues Package zu dem Store hinzu
     * @param packageDeal Das neue Package
     */
    public void addPackage(Package packageDeal){
        this.packages.add(packageDeal);
    }
}
