/**
 * Erweitert Cards insofern, dass es im Stack auch ein Deck gibt
 */
public class Stack extends Cards{
    private Cards deck;

    /**
     * Erstellt einen neuen Stack aus den User Cards und seinem Deck
     * @param cards Alle Cards des Users
     * @param deck Sein Deck
     */
    public Stack(Cards cards, Cards deck) {
        super(cards.getCards());
        this.deck = deck;
    }

    /**
     * Fügt ein neues Deck in den Stack ein
     * @param newCards Gesamtes Deck
     */
    public void addDeck(Cards newCards) {
        this.deck = newCards;
    }

    /**
     * Holt das gesamte Deck
     * @return Gesamtes Deck
     */
    public Cards getDeck() {
        return this.deck;
    }

    /**
     * Löscht eine Card aus dem Deck
     * @param toDel Card zum löschen
     */
    public void delDeck(Card toDel) {
        this.deck.delCard(toDel);
    }

    /**
     * Fügt dem deck eine neue Card ein
     * @param toAdd Neue Card
     */
    public void addDeckCard(Card toAdd){
        this.deck.addCard(toAdd);
    }
}
